
from AppKit import *
from mojo.UI import *
from mojo.roboFont import CurrentFont, CurrentGlyph, AllFonts, OpenWindow

def ShowFontWindow(font):
    windows = [w for w in NSApp().orderedWindows() if w.isVisible()]
    for window in windows:
        delegate = window.delegate()
        if not hasattr(delegate, "vanillaWrapper"):
            continue            
        vanillaWrapper = delegate.vanillaWrapper()
        if "DoodleFontWindow" in vanillaWrapper.__class__.__name__:
            if font.path == vanillaWrapper.document.font.path:                
                vanillaWrapper.w.show()
                
def getSkateboard():
    windows = [w for w in NSApp().orderedWindows() if w.isVisible()]
    for window in windows:
        delegate = window.delegate()
        if not hasattr(delegate, "vanillaWrapper"):
            continue            
        vanillaWrapper = delegate.vanillaWrapper()
        if vanillaWrapper.__class__.__name__ == "SkateBoard":
            return vanillaWrapper

def getSkateboardDesignSpace():
    # return the designspace currently open in skateboard
    skateboards = []
    windows = [w for w in NSApp().orderedWindows() if w.isVisible()]
    for window in windows:
        delegate = window.delegate()
        if not hasattr(delegate, "vanillaWrapper"):
            continue            
        vanillaWrapper = delegate.vanillaWrapper()
        if vanillaWrapper.__class__.__name__ == "SkateBoard":
            return vanillaWrapper.getDesignSpace()
    
def getDesignSpaceDocuments():
    """ Try to find designspace windows."""
    designSpaces = []
    windows = [w for w in NSApp().orderedWindows() if w.isVisible()]
    for window in windows:
        delegate = window.delegate()
        if not hasattr(delegate, "vanillaWrapper"):
            continue            
        vanillaWrapper = delegate.vanillaWrapper()
        if vanillaWrapper.__class__.__name__ == "DesignSpaceEditor":
            designSpaces.append(vanillaWrapper)
    return designSpaces

# see if we can find a designspace for the current UFO
def CurrentDesignSpace():
    docs = getDesignSpaceDocuments()
    # can we find the designspace that belongs to the currentfont?
    f = CurrentFont()
    if f is not None:
        for doc in docs:
            for sourceDescriptor in doc.doc.sources:
                if sourceDescriptor.path == f.path:
                    return doc.doc
    # if we have no currentfont, can we find the designspace that is the first?
    if docs:
        return docs[0].doc
    # we have no open fonts, no open docs
    return None

if __name__ == "__main__":
    ds = getSkateboardDesignSpace()
    for m in ds.sources:
        print("master", m.path)
    print("document", ds.path)
    print(ds.update())
    # result = CurrentDesignSpace()
    # if result is None:
    #     print("no .designspace open")
    # if result is not None:
    #     print("document source", result.path)
    #     for sd in result.sources:
    #         print("sourcedescriptor", sd.path)
    #     result.loadFonts()    # because otherwise it wont work
