from mojo.events import addObserver
from getDesignSpaceWindow import getSkateboard
import skateboard

import sys
import os
root = os.path.dirname(__file__)
if root not in sys.path:
    sys.path.append(root)

def openPathWithSkateboard(path):
    sb = getSkateboard()
    needsClosing = False
    if sb is None:
        #print("opening a new skateboard window")
        OpenWindow(skateboard.SkateBoard)
    else:
        #print("already have one")
        if sb.ds != None:
            #print("close existing document")
            sb.mainWindow_closeDocument()
    #print("ready to open new document")
    sb = getSkateboard()
    sb.mainWindow_openDocumentWithPath(path)

class DesignSpaceOpener(object):
    def __init__(self):
        addObserver(self, "openFile", "applicationOpenFile")
    def openFile(self, notification):
        fileHandler = notification["fileHandler"]
        path = notification["path"]
        ext = os.path.splitext(path)[-1]
        if ext.lower() not in [".designspace", ".sp3"]:
            return
        openPathWithSkateboard(path)
        fileHandler["opened"] = True

try:
    DesignSpaceOpener()
except:
    print("Could not add DesignSpaceOpener.")
