import ufoProcessor
import designspaceProblems
from getDesignSpaceWindow import getSkateboard
import importlib
importlib.reload(designspaceProblems)
from fontTools.designspaceLib import SourceDescriptor, InstanceDescriptor, AxisDescriptor, RuleDescriptor
from fontParts.fontshell import RFont
from pprint import pprint
import os
import glob

import main

print(main)
main.openPathWithSkateboard()
#from main import openPathWithSkateboard

axisMin = 0
axisDefault = 0
axisMax = 1000

widths = [
    
    ('narrow', 50),
    ('condensed', 75),
    ('normal', 100),
    ('medium', 100),
    ('expanded', 112.5),
    ('wide', 200),
    ]
    
weights = [
    ('thin', 100),
    ('extralight', 200),
    ('ultralight', 200),
    ('light', 300),
    ('normal', 400),
    ('regular', 400),
    ('medium', 500),
    ('semibold', 600),
    ('demibold', 600),
    ('bold', 700),
    ('extrabold', 800),
    ('ultrabold', 800),
    ('black', 900),
    ('heavy', 900),
    ]


ds = ufoProcessor.DesignSpaceProcessor()

root = []
sources = []
for f in AllFonts():
    r = os.path.dirname(f.path)
    if not r in root:
        root.append(r)
    loc = {}
    t = f.info.styleName.lower()
    print(t)
    for k, v in weights:
        if k in t:
            loc['weight'] = v
    for k, v in widths:
        if k in t:
            loc['width'] = v

    sd = SourceDescriptor()
    sd.path = f.path
    sd.familyName = f.info.familyName
    sd.styleName = f.info.styleName
    sd.location = loc
    ds.sources.append(sd)

print([s.location for s in sources])
axes = {}
for  loc in [s.location for s in ds.sources]:
    print(loc)
    for axisName, value in loc.items():
        if not axisName in axes:
            axes[axisName] = [None, None]    # axis Min, axis Max
        if axes[axisName][0] is None:
            axes[axisName][0] = value
        else:
            axes[axisName][0] = min(axes[axisName][0], value)
        if axes[axisName][1] is None:
            axes[axisName][1] = value
        else:
            axes[axisName][1] = max(axes[axisName][1], value)

tags = {'weight': 'wght', 'width': "wdth"}
for axisName, values in axes.items():
    print(axisName, values)
    ad = AxisDescriptor()
    ad.name = axisName
    ad.minimum = values[0]
    ad.default = values[0]
    ad.maximum = values[1]
    ad.tag = tags.get(axisName)
    print(ad)
    ds.addAxis(ad)

checker = designspaceProblems.DesignSpaceChecker(ds)
print(checker.checkDesignSpaceGeometry())
print(checker.checkSources())
print(checker.problems)
    

if not checker.hasStructuralProblems():

    if len(root) > 1:
        print('sources from different folders', root)
    elif len(root) == 0:
        print("no fonts..")
    else:
        p = os.path.join(root[0], "guessed.designspace")
        print(p)
        ds.write(p)

    sb = getSkateboard()
    print(sb)
    if sb is not None:
        sb.mainWindow_closeDocument()
        sb.mainWindow_openDocumentWithPath(p)
        