# coding: utf-8
# the best and smallest viable designspace implementation in RF3
import AppKit
import os, time, math, random, sys
import mutatorMath.objects.mutator
import weakref
import ufoProcessor.varModels
from ufoProcessor.emptyPen import checkGlyphIsEmpty
import ufoProcessor
import vanilla
from mojo.drawingTools import *

import colorsys

def roundedRect(x, y, w, h, offset=25):
    newPath()
    moveTo((x+offset, y))
    lineTo((x+w-offset, y))
    curveTo((x+w, y), (x+w, y), (x+w, y+offset))
    lineTo((x+w, y+h-offset))
    curveTo((x+w, y+h), (x+w, y+h), (x+w-offset, y+h))
    lineTo((x+offset, y+h))
    curveTo((x, y+h), (x, y+h), (x, y+h-offset))
    lineTo((x, y+offset))
    curveTo((x, y), (x, y), (x+offset, y))
    closePath()
    drawPath()

def getColor(steps, index, saturation=1):
    return colorsys.hsv_to_rgb(index/(steps*1.0), saturation, 1)

def showInFinder(path):
    url = AppKit.NSURL.fileURLWithPath_(path)
    workspace = AppKit.NSWorkspace.sharedWorkspace()
    workspace.activateFileViewerSelectingURLs_([url])

def ip(a, b, f):
    return a+f*(b-a)
    
def needle(start, end, startWidth, endWidth, steps=4):
    save()
    lineDash(None)
    for i in range(steps):
        f = float(i)/steps
        fn = float(i+1)/steps
        strokeWidth(ip(startWidth, endWidth, f))
        line(
            (ip(start[0], end[0], f), ip(start[1], end[1], f)),
            (ip(start[0], end[0], fn), ip(start[1], end[1], fn)),
            )
    restore()

def followComponents(font, names):
    # make a list of the extended group of names
    # needed to draw these glyphs
    if not font: return []
    allNames = []
    newNames = []
    for n in names:
        if n is None: continue
        if not n in font: continue
        g = font[n]
        allNames.append(g.name)
        if not g.components:
            continue
        [newNames.append(c.baseGlyph) for c in g.components if c.baseGlyph not in newNames]
    if newNames:
        [allNames.append(n) for n in followComponents(font, newNames) if n not in allNames]
    return list(set(allNames))

# https://www.geeksforgeeks.org/program-check-three-points-collinear/
def polygon_area(points):  
    area = 0
    q = points[-1]
    for p in points:  
        area += p[0] * q[1] - p[1] * q[0]
        q = p
    return area / 2

def plot(points):
    if len(points) < 3:
        return None
    a = 0
    for pi, p in enumerate(points[:-2]):
        npt = points[pi+1]
        nnpt = points[pi+2]
        a += abs(polygon_area([points[pi], npt, nnpt]))
    return a
