
def findCluster(g, verbose=False):
    pairs = {}    # dict of selected things, indexed per contour
    singles = {}
    selected = []
    for ci, c in enumerate(g.contours):
        bpts = c.bPoints
        for pi, p in enumerate(bpts):
            if p.selected:
                selected.append(p)
    for ci, c in enumerate(g.contours):
        bpts = c.bPoints
        for pi, p in enumerate(bpts):
            #print(pi, p)
            if p.selected:
                if verbose:
                    print()
                previous = bpts[pi-1]
                nextP = bpts[(pi+1)%len(c.bPoints)]
                if verbose:
                    print('prev',    pi-1,                  previous,     previous.type,  previous in selected)
                    print('curr',    pi,                    p,            p.type,         p in selected)
                    print('next',    (pi+1)%len(c.bPoints), nextP,        nextP.type,     nextP in selected)
                isSingle = True
                if previous in selected:
                    # only accept if it is a tangent section
                    if not "curve" in [p.type, previous.type]:
                        continue
                    if previous.bcpOut == p.bcpIn == (0,0):
                        if not ci in pairs:
                            pairs[ci] = []
                        if (previous, p) not in pairs[ci]:
                            pairs[ci].append((previous, p))
                            isSingle = False
                elif nextP in selected:
                    if not "curve" in [p.type, nextP.type]:
                        continue
                    if nextP.bcpIn == p.bcpOut == (0,0):
                        if not ci in pairs:
                            pairs[ci] = []
                        if (p, nextP) not in pairs[ci]:
                            pairs[ci].append((p, nextP))
                            isSingle = False
                if isSingle:
                    if p.bcpIn != (0,0) and p.bcpOut != (0,0):
                        # single curve point. Might not be smooth
                        #print("single", p.type)
                        if not ci in singles:
                            singles[ci] = []
                        singles[ci].append(p)
    return singles, pairs

if __name__ == "__main__":
    g = CurrentGlyph()
    if g is not None:
        #print(g.name)
        s, p = findCluster(g, verbose=False)
        
        print('singles', s)
        print('pairs', p)