import ufoProcessor.varModels
import ufoProcessor
from fontTools.designspaceLib import DesignSpaceDocument, SourceDescriptor, InstanceDescriptor, AxisDescriptor, RuleDescriptor
from fontTools.varLib.models import normalizeValue, normalizeLocation

from fontParts.fontshell import RFont
from fontParts.fontshell import RGlyph
from skateboard import SkateboardDesignSpaceProcessor
from mutatorMath import Location

"""
    An object that renders and stores partial UFOs
    from a designspace document.
    
    + glyphs
    + fonts per location
    + special treatments (muted masters)
    + partial kerning
    + some sort of queue system
"""

class Request(object):
    pass
    
class Renderer(object):
    def __init__(self, ds):
        self.reset()

    def reset(self):
        self.fonts = {}
        self.requests = []
        self.ds = ds
        self.default = self.ds.fonts.get(self.ds.findDefault().name)
    
    def close(self):
        self.ds = None
        self.fonts = None
    
    def newFont(self, location):
        f = RFont(showInterface=False)
        f.info.unitsPerEm = self.default.info.unitsPerEm
        f.info.ascender = self.default.info.ascender
        f.info.descender = self.default.info.descender
        return f
        
    def request(self, location, glyphs=None, pairs=None, info=None):
        key = tuple(sorted(location.items()))
        if not key in self.fonts:
            self.fonts[key] = f = self.newFont(location)
        else:
            f = self.fonts[key]
        print(f)
        for name in glyphs:
            try:
                masters, sourceGlyphObjects, currentMutator, componentMutators = self.ds.makeGlyphMutator(dd.glyph.name)
            except (ValueError):
                print("error processing masters", traceback.format_exc())
            


if __name__ == "__main__":
    import random
    
    path = "/Users/erik/code/skateboardExtension/ufo/MutatorSans.designspace"
    ds = SkateboardDesignSpaceProcessor()
    ds.read(path)
    ds.loadFonts(reload=True)
    print(ds)
    r = Renderer(ds)
    print(r)
    loc = Location()
    for axisRecord in ds.axes:
        loc[axisRecord.name] = axisRecord.minimum + random.random() * (axisRecord.maximum-axisRecord.minimum)
    names = []
    for i in range(5):
        n = random.choice(ds.glyphNames)
        if n not in names:
            names.append(n)
    print(loc, names)
    print(r.request(loc, glyphs=names), )